function [x,y,F,f,F_x,F_y,F_XY,F_YX]=bidimensional_gauss(m_x,m_y,s_x,s_y,r)
x_max=m_x+4*max(s_x,s_y);
x_min=m_x-4*max(s_x,s_y);
y_max=m_y+4*max(s_x,s_y);
y_min=m_y-4*max(s_x,s_y);
dx=(x_max-x_min)/250;
dy=(y_max-y_min)/250;

x=x_min:dx:x_max;
y=y_min:dy:y_max;


f=zeros(length(x),length(y));
F=f;
K = [s_x^2 r*s_x*s_y; r*s_x*s_y s_y^2 ];
A=1/((2*pi)*sqrt(det(K)));
%Calculo de Densidad Conjunta
h= waitbar(0,'Calculando densidad bivariadad');
for i=1:length(x)
    for j=1:length(y)
        z=[x(i)-m_x y(j)-m_y];
        f(i,j) = A*exp(-1/2*(z*(K\z')));
    end
    waitbar(i/length(x),h,sprintf('Progreso Clculo de Densidad Conjunta: %d%% ',round(i/length(x)*100)));
end
delete(h)

%Clculo de Densidades Marginales
%f_X(x)
f_X=zeros(length(x));
for i=1:length(x)
    f_X(i)=sum(f(i,:)*dy);
end
%f_Y(y)
f_Y=zeros(length(y));
f_XY=zeros(length(x),length(y));
f_YX=zeros(length(x),length(y));
for j=1:length(y)
    f_Y(j)=sum(f(:,j)*dx);
end
%Clculo de Densidades Condicionales
%f_X|Y(x|y)
for j=1:length(y)
    f_XY(:,j)=f(:,j)/f_Y(j);
end
%f_Y|X(y|x)
for i=1:length(x)
    f_YX(i,:)=f(i,:)/f_X(i);
end

h= waitbar(0,'Calculando funcin acumulada de probabilidad bivariada');
for i=1:length(x)
    for j=1:length(y)
        F(i,j)=bvcdf(x(i),y(j),x,y,f);
    end
    waitbar(i/length(x),h,sprintf('Progreso Clculo de Distribucin: %d%% ',round(i/length(x)*100)));
end
delete(h)

%Clculo de Distribuciones Marginales
F_x(:,1)=F(:,length(y));
F_y(1,:)=F(length(x),:);

%Clculo de Distribuciones Condicionales
F_XY=zeros(length(x),length(y));
F_YX=F_XY;

h= waitbar(0,'Calculando Funcin Acumulada de Probabilidad Condicional');

for i=1:length(x)
    for j=1:length(y)
        F_XY(i,j)=sum(f_XY(1:i,j)*dx);
        F_YX(i,j)=sum(f_YX(i,1:j)*dy);
    end
    waitbar(i/length(x),h,sprintf('Progreso Clculo de Distribuciones Condicionales: %d%% ',round(i/length(x)*100)));
end
delete(h)
