function muestreo_secuencial(m_x,m_y,s_x,s_y,r,N_sim)
%script para generar nmeros aleatorios que siguen una Gaussiana bivariada
%utilzando muestreo secuencial
%con parmetros 
% m_x: media en x
% m_y: media en y
% s_x: desviacin estndar en x
% s_y: desviacin estndar en y
% r  : coeficiente de correlacin
%N_sim: nmero de muestras
%Generacin de distribuciones marginales y condicionales a partir de una
%Gaussiana bivariada.

[X,Y,F,f,F_X,F_Y,F_XY,F_YX]=bidimensional_gauss(m_x,m_y,s_x,s_y,r);
x_min=min(X);
x_max=max(X);
y_min=min(Y);
y_max=max(Y);

figure(1),clf;
h= waitbar(0,'Por favor espere');
hold on
for i=1:N_sim
    %Generamos 
    u=rand;
    v=rand;
    figure(1)
    subplot(1,2,1), scatter(u,v,'b.')
    axis([-0.1 1.1 -0.1 1.1])
    xlabel('u_1')
    ylabel('u_2')
    set(gca,'DataAspectRatio', [1 1 1])
    hold on
    %Clculo de pseudo inversa en direccin de X
    index_x=find(F_X<u, 1, 'last' );
    x=X(index_x);
    %Clculo de pseudo inversa en direccin de Y
    y=Y(find(F_YX(index_x,:)<v, 1, 'last' ));
    subplot(1,2,2), scatter(x,y,'b.')
    xlabel('x_1')
    ylabel('x_2')
    axis([x_min x_max y_min y_max])
    set(gca,'DataAspectRatio', [1 1 1])
    hold on
    waitbar(i/N_sim,h,sprintf('Progreso de la Simulacin: %d%% ',round(i/N_sim*100)));
    %pause(0.01)
end
hold off
delete(h)
